#include<queue>
#include<iostream>

using namespace std;

//Pre: c=C i c1 i c2 són buides
void distribucio(queue<pair<int,int> > & c, 
		 queue<pair<int,int> > & c1, queue<pair<int,int> > & c2){
int e1=0;
int e2=0;

/*{Inv: c1 i c2 són una distribució justa dels elements C que no són a c
        e1 és el temps d'espera a c1
        e2 és el temps d'espera a c2
 */

while (not c.empty()){
  if (e1 > e2) {
    c2.push(c.front());
    e2+=c.front().second;
  }
  else {
    c1.push(c.front());
    e1+=c.front().second;
  }
  c.pop();  
 }
//Post: c1 i c2 són una distribució justa dels elements de C
}

void llegir_cua(queue<pair<int,int> > & c){
  int x,y;
  cin >> x >> y;
  while (x!=0 or y!=0){
    c.push(make_pair(x,y));
    cin >> x >> y;
  }
}

void escriu_cua(queue<pair<int,int> > & c){
  while (not c.empty()){
    cout << c.front().first << " " << c.front().second << endl;
    c.pop();
  }
}


int main() {
  queue<pair<int,int> > c,c1,c2;
  cout << "Introdueix la cua:"<< endl;
  llegir_cua(c);
  distribucio(c,c1,c2);
  cout << "Primera cua:"<< endl;
  escriu_cua(c1);
  cout << endl << "Segona cua:"<< endl;
  escriu_cua(c2);
}
